# -*- coding: utf-8 -*-
"""DetectorArray.

This file is automatically generated. Do not modify!
"""

from micado.main.HardwareThing import HardwareThing, persistent
from micado.hardware.Detector import Detector
from micado.hardware.DarkCurrent import DarkCurrent
from micado.hardware.ShotNoise import ShotNoise
from micado.hardware.QuantumEfficiencyCurve import QuantumEfficiencyCurve
from micado.hardware.LinearityCurve import LinearityCurve
from micado.hardware.SummedExposure import SummedExposure
from micado.hardware.PoorMansHxRGReadoutNoise import PoorMansHxRGReadoutNoise
from micado.hardware.ReferencePixelBorder import ReferencePixelBorder


class DetectorArray(HardwareThing):
    """A detector array."""

    dummy_detectorarray = persistent("dummy [][None]", int, 42)

    name = persistent("Name of the detector array [DET NAME][None]", str, "")

    image_plane_id = persistent(
        "Number of this detector in the image plane [DET IMAGE_PL][None]", int, 0
    )

    temperature = persistent(
        "Temperature of detector array [DET TEMPERAT][C]", float, -230.0
    )

    readout = persistent("Readout mode of the detector [DET READOUT][None]", str, "CDS")

    detector_array_list = persistent("Detectors [][None]", Detector, [])

    dark_current = persistent("DarkCurrent [][None]", DarkCurrent, None)

    shot_noise = persistent("ShotNoise [][None]", ShotNoise, None)

    qe_curve = persistent(
        "QuantumEfficiencyCurve [][None]", QuantumEfficiencyCurve, None
    )

    linearity = persistent("LinearityCurve [][None]", LinearityCurve, None)

    exposure_action = persistent("SummedExposure [][None]", SummedExposure, None)

    readout_noise = persistent("ReadoutNoise [][None]", PoorMansHxRGReadoutNoise, None)

    border_reference_pixels = persistent(
        "ReferencePixelBorder [][None]", ReferencePixelBorder, None
    )
