# -*- coding: utf-8 -*-
"""Instrument.

This file is automatically generated. Do not modify!
"""

from micado.main.HardwareThing import HardwareThing, persistent
from micado.hardware.FilterWheel import FilterWheel
from micado.hardware.PupilWheel import PupilWheel
from micado.hardware.SurfaceList import SurfaceList
from micado.hardware.NonCommonPathAberration import NonCommonPathAberration


class Instrument(HardwareThing):
    """The instrument."""

    dummy_instrument = persistent("dummy [][None]", int, 42)

    name = persistent("Name of instrument [INS NAME][None]", str, "")

    temperature = persistent(
        "Temperature of the instrument. [INS TEMPERAT][C]", float, -190.0
    )

    ocs__pxscale = persistent("Pixel scale [OCS PXSCALE][arcsec/pix]", float, 0.004)

    plate_scale = persistent(
        "Plate scale [INS PLATE_SC][arcsec/mm]", float, 0.26666666666
    )

    drot = persistent("Derotator angle [INS DROT][degree]", float, 0.0)

    filter_wheel_1 = persistent("The first filter wheel [][None]", FilterWheel, None)

    filter_wheel_2 = persistent("The second filter wheel [][None]", FilterWheel, None)

    pupil_wheel = persistent("The pupil wheel [][None]", PupilWheel, None)

    static_surfaces = persistent("Static Mirrors [][None]", SurfaceList, None)

    ncpas_psf = persistent(
        "Non Common Path Aberrations [][None]", NonCommonPathAberration, None
    )
